// Menu Cienaga

const int v_arriba = 1; //
const int v_abajo  = 2; //
const int v_menu   = 3; //

int set_year;
int set_month;
int set_dayOfMonth;
int set_hour;
int set_minute;
int set_second;

int OPMENU = 1;
  
int refrescarMENU = 1;
int boton_pulsado;
int NOSALIR = 0;
int lectura = 0;  //

// int vtecla = 0;

int LeerTeclado(){
  
  if ((long)( millis() - vmillis ) >= 0) {
    vmillis += 100;
    delay(100); // Esto evita rebotes en el teclado y hace que las pulsaciones sean no seguidas    
    int lectura = analogRead(boton);

    if (lectura>200){
	  return v_arriba;}
    else if (lectura>80){
	  return v_abajo;}
    else if (lectura>10){
	  return v_menu;}
    else {return 0;}
  }
}

void Serial_printInt(int valor, const char* cero){
  if (valor < 10) {Serial.print(cero);} Serial.print(valor);
}

void Serial_printInt(float valor, const char* cero){
  if (valor < 10) {Serial.print(cero);} Serial.print(valor,1);
}

void CambiarAMenu(int estado){
  estadoMenu = estado;
  refrescarMENU = 1;
  OPMENU = 1;
  //boton_pulsado = 0;
}

// Un intento de simplificar las cosas, pero no que termino de acabarlo
  void actuarBotonOpcion(int menuAnterior, int submenus, int opmenumax) {

      if      (boton_pulsado == v_arriba) {refrescarMENU=1; if (--OPMENU == 0) {OPMENU=opmenumax;}}
      else if (boton_pulsado == v_abajo)  {refrescarMENU=1; if (++OPMENU == opmenumax+1) {OPMENU=1;}}
      else if (boton_pulsado == v_menu) { 
           if (OPMENU == opmenumax) {CambiarAMenu(menuAnterior);} // Regresamos al menu anterior
           else {CambiarAMenu(submenus+OPMENU);}                  // Entramos en el submenu
           }
  }

void actuarBotonInt(int *variable, int minvalor, int maxvalor, const char* cero){
    if (boton_pulsado == v_arriba) {if (++*variable > maxvalor) {*variable = minvalor;}; Serial_printInt(*variable,cero);};
    if (boton_pulsado == v_abajo)  {if (--*variable < minvalor) {*variable = maxvalor;}; Serial_printInt(*variable,cero);};
  }
  
 /* void actuarBotonFloat(float *variable, float minvalor, float maxvalor, const char* cero){
    if (boton_pulsado == v_arriba) {*variable += 0.1; if (*variable > maxvalor) {*variable = minvalor;}; Serial_printInt(*variable,cero);};
    if (boton_pulsado == v_abajo)  {*variable -= 0.1; if (*variable < minvalor) {*variable = maxvalor;}; Serial_printInt(*variable,cero);};
  }
*/
void Menu(){

  boton_pulsado = LeerTeclado();
  
  // Todos los delay siguientes se pueden eliminar pues LeerTeclado ya se asegura un tiempo minimo entre pulsaciones

  switch (estadoMenu) {
  
    case 0: // Actualiza el LCD y comprueba si se entra en el menu principal
      if (refrescarLCD == 1){
        refrescarLCD = 0;
        fecha(0);   //Pintamos hora / fecha / nombre-CIENAGA en la linea 0
        infolcd();  //Estructura general de la pantalla principal
        //setCur(3,12); Serial.print(boton_pulsado); Serial.print("   ");
         
        }
      if (boton_pulsado == v_menu) CambiarAMenu(1000);
      break;
    
    case 1000: // Muestra el mensaje de inicial de configuracion y entra en el menu principal
      LCD_Reset(1);
      setCur(3,1); Serial.print("CONFIGURACION");
      delay(1000); // antenemos el mensaje 1 segundo
      CambiarAMenu(1001); // Entraremos en el Menu Principal
      break;
    
 
          

    case 1001: // Menu Principal
        
      if ((OPMENU < 5)&&(refrescarMENU==1)){
      LCD_Reset(1);
      setCur(0,0); Serial.print("1.CONF. RELE       "); if (OPMENU == 1) {Serial.print("<");};
      setCur(0,1); Serial.print("2.CTRL. TEMP.      "); if (OPMENU == 2) {Serial.print("<");};
      setCur(0,2); Serial.print("3.INFO. TEMP.      "); if (OPMENU == 3) {Serial.print("<");};
      setCur(0,3); Serial.print("4.CONF. RELOJ      "); if (OPMENU == 4) {Serial.print("<");};
      refrescarMENU=0;
    } else if ((OPMENU >= 5)&&(refrescarMENU==1)){
      LCD_Reset(1);
      setCur(0,0); Serial.print("5.SALIR            "); if (OPMENU==5) {Serial.print("<");}
      refrescarMENU=0;
    }
    
     actuarBotonOpcion(0,0,5);
     break;
     
 ////////////// CONFIGURACION DE RELE, EL 3 Y 4 SON PARA LOS VENTILADORES
 ////////////// EL 3 ESTA CONFIGURADO PERO DESACTIVADO POR SI HAY QUE EMPLEARLO EN OTRA COSA
     
   case 1: 
    
   //Menu principal
   
    if ((OPMENU < 4)&&(refrescarMENU==1)){ // CAMBIA EL 4 POR 5 SI SE ACTIVA EL R3
        LCD_Reset(1);
        //delay(300); 
        
        setCur(0,0);  Serial.print("R1 F. ALIMENTACION "); if (OPMENU == 1) {Serial.print("<");};
        setCur(0,1);  Serial.print("R2 CO2             "); if (OPMENU == 2) {Serial.print("<");};
    //  setCur(0,2);  Serial.print("R3 DESACTIVADO     "); if (OPMENU == 3) {Serial.print("<");}; CAMBIAR OPEN MENU 
        setCur(0,3);  Serial.print("SALIR              "); if (OPMENU == 3) {Serial.print("<");}; //SI SE ACTIVA
        refrescarMENU=0;
        //delay(300);
        }  
     
       actuarBotonOpcion(1001,10,3); ////CAMBIAR 3 POR 4 SI SE AVTIVA R3
       break;
       
 //////////////// RELE PARA ENCENDER LA F.A.
       
       case 11: 
            
            if ((OPMENU < 6)&&(refrescarMENU==1)){
            LCD_Reset(1);
            delay(300);
            
            setCur(1,0);  Serial.print("R1 F. ALIMENTACION ");
            setCur(5,1);  Serial.print("ON     OFF     ");
            setCur(4,2);  Serial_printInt(rel1on,"0"); Serial.print(":");
            setCur(7,2);  Serial_printInt(rel1minon,"0");
            setCur(11,2); Serial_printInt(rel1off,"0"); Serial.print(":");
            setCur(14,2); Serial_printInt(rel1minoff,"0");
            setCur(0,3); Serial.print("ESC");
            setCur(17,3); Serial.print("GRA");
            refrescarMENU=0;
            //delay(300);
            }
            if (boton_pulsado == v_menu) {OPMENU++;} 
        
            if (OPMENU == 1){
             setCur(3,2); Serial.print(">");
             setCur(4,2); actuarBotonInt(&rel1on, 0, 23, "0");
             }
            else if (OPMENU == 2){
             setCur(3,2); Serial.print(" ");
             setCur(9,2); Serial.print("<");   
             setCur(7,2); actuarBotonInt(&rel1minon, 0, 59, "0");
             }
            else if (OPMENU == 3){
             setCur(9,2); Serial.print(" ");
             setCur(10,2); Serial.print(">");
             setCur(11,2); actuarBotonInt(&rel1off, 0, 23, "0");
             }
            else if (OPMENU == 4){
             setCur(10,2); Serial.print(" ");
             setCur(16,2); Serial.print("<");
             setCur(14,2); actuarBotonInt(&rel1minoff, 0, 59, "0");
             }
            else if (OPMENU == 5) {
          /////////SALIMOS
             setCur(16,2); Serial.print(" ");
             setCur(3,3); Serial.print("<");
             if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
             CambiarAMenu(1);  
             }
             }
            else if (OPMENU == 6) {      
          /////// Grabamos los valores y salimos al menu anterior
             setCur(3,3); Serial.print(" ");
             setCur(16,3); Serial.print(">");
        
             if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
        
             EEPROM.write(rel1_on,rel1on);
             EEPROM.write(rel1_min_on,rel1minon);
             EEPROM.write(rel1_off,rel1off);  
             EEPROM.write(rel1_min_off,rel1minoff);
        
            CambiarAMenu(1);  
            }
            }  
           else if (OPMENU ==7) {OPMENU = 1; setCur(16,3); Serial.print(" ");}
     
       break;
       
////////////////////// RELE PARA CONTROLAR EL CO2 CO2
       
           case 12: 
            
            if ((OPMENU < 6)&&(refrescarMENU==1)){
            LCD_Reset(1);
            delay(300);
            
            setCur(7,0);  Serial.print("R2 CO2");
            setCur(5,1);  Serial.print("ON     OFF     ");
            setCur(4,2);  Serial_printInt(rel2on,"0"); Serial.print(":");
            setCur(7,2);  Serial_printInt(rel2minon,"0");
            setCur(11,2); Serial_printInt(rel2off,"0"); Serial.print(":");
            setCur(14,2); Serial_printInt(rel2minoff,"0");
            setCur(0,3); Serial.print("ESC");
            setCur(17,3); Serial.print("GRA");
            refrescarMENU=0;
            //delay(300);
            }
            if (boton_pulsado == v_menu) {OPMENU++;} 
        
            if (OPMENU == 1){
             setCur(3,2); Serial.print(">");
             setCur(4,2); actuarBotonInt(&rel2on, 0, 23, "0");
             }
            else if (OPMENU == 2){
             setCur(3,2); Serial.print(" ");
             setCur(9,2); Serial.print("<");   
             setCur(7,2); actuarBotonInt(&rel2minon, 0, 59, "0");
             }
            else if (OPMENU == 3){
             setCur(9,2); Serial.print(" ");
             setCur(10,2); Serial.print(">");
             setCur(11,2); actuarBotonInt(&rel2off, 0, 23, "0");
             }
            else if (OPMENU == 4){
             setCur(10,2); Serial.print(" ");
             setCur(16,2); Serial.print("<");
             setCur(14,2); actuarBotonInt(&rel2minoff, 0, 59, "0");
             }
            else if (OPMENU == 5) {
          ///////SALIMOS
             setCur(16,2); Serial.print(" ");
             setCur(3,3); Serial.print("<");
             if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
             CambiarAMenu(1);  
             }
             }
            else if (OPMENU == 6) {      
          ////// Grabamos los valores y salimos al menu anterior
             setCur(3,3); Serial.print(" ");
             setCur(16,3); Serial.print(">");
        
             if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
        
             EEPROM.write(rel2_on,rel2on);
             EEPROM.write(rel2_min_on,rel2minon);
             EEPROM.write(rel2_off,rel2off);  
             EEPROM.write(rel2_min_off,rel2minoff);
        
            CambiarAMenu(1);  
            }
            }  
           
           else if (OPMENU ==7) {OPMENU = 1; setCur(16,3); Serial.print(" ");}
           
        break;
       
        /*  case 13: // DESACTIVADO, PREPARADO, PERO EMPLEADO PARA ACTIVAR VENTILADOR
            
            if ((OPMENU < 6)&&(refrescarMENU==1)){
            LCD_Reset(1);
            delay(300);
            
            setCur(3,0);  Serial.print("R3 DESACTIVADO ");
            setCur(5,1);  Serial.print("ON     OFF     ");
            setCur(4,2);  Serial_printInt(rel3on,"0"); Serial.print(":");
            setCur(7,2);  Serial_printInt(rel3minon,"0");
            setCur(11,2); Serial_printInt(rel3off,"0"); Serial.print(":");
            setCur(14,2); Serial_printInt(rel3minoff,"0");
            setCur(0,3); Serial.print("ESC");
            setCur(17,3); Serial.print("GRA");
            refrescarMENU=0;
            //delay(300);
            }
            if (boton_pulsado == v_menu) {OPMENU++;} 
        
            if (OPMENU == 1){
             setCur(3,2); Serial.print(">");
             setCur(4,2); actuarBotonInt(&rel3on, 0, 23, "0");
             }
            else if (OPMENU == 2){
             setCur(3,2); Serial.print(" ");
             setCur(9,2); Serial.print("<");   
             setCur(7,2); actuarBotonInt(&rel3minon, 0, 59, "0");
             }
            else if (OPMENU == 3){
             setCur(9,2); Serial.print(" ");
             setCur(10,2); Serial.print(">");
             setCur(11,2); actuarBotonInt(&rel3off, 0, 23, "0");
             }
            else if (OPMENU == 4){
             setCur(10,2); Serial.print(" ");
             setCur(16,2); Serial.print("<");
             setCur(14,2); actuarBotonInt(&rel3minoff, 0, 59, "0");
             }
            else if (OPMENU == 5) {
             //SALIMOS
             setCur(16,2); Serial.print(" ");
             setCur(3,3); Serial.print("<");
             if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
             CambiarAMenu(1);  
             }
             }
            else if (OPMENU == 6) {      
             // Grabamos los valores y salimos al menu anterior
             setCur(3,3); Serial.print(" ");
             setCur(16,3); Serial.print(">");
        
             if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
        
             EEPROM.write(rel3_on,rel3on);
             EEPROM.write(rel3_min_on,rel3minon);
             EEPROM.write(rel3_off,rel3off);  
             EEPROM.write(rel3_min_off,rel3minoff);
        
            CambiarAMenu(1);  
            }
            }  
           
           else if (OPMENU ==7) {OPMENU = 1; setCur(16,3); Serial.print(" ");}
           
        break;
    */     
          case 14: // SALIMOS A MENU PRINCIPAL
            
            if ((OPMENU < 5)&&(refrescarMENU==1)){
                     
               CambiarAMenu(1001);
             }
       
        break;
        
            // PARA AJUSTAR LAS TEMPERATURAS A LAS QUE ENCIENDEN O APAGAN LOS VENTILADORES
           // Y LAS TEMPERATURAS DE LOS LED POR SI HAY QUE APAGARLOS POR CALENTON
       
    case 2:      
        
      if ((OPMENU < 5)&&(refrescarMENU==1)){
        LCD_Reset(1);
        setCur(0,0); Serial.print("VENTILADORES       "); if (OPMENU == 1) {Serial.print("<");};
        setCur(0,1); Serial.print("TEMP. LED          "); if (OPMENU == 2) {Serial.print("<");};
        setCur(0,3); Serial.print("SALIR              "); if (OPMENU == 3) {Serial.print("<");};
        refrescarMENU=0;
        }
              
       actuarBotonOpcion(1001,20,3);
       
      break;
      
/////////////////////VENTILADORES
      
        case 21: 
   
             if ((OPMENU < 5)&&(refrescarMENU==1)){
             LCD_Reset(1);
             setCur(4,0); Serial.print("VENTILADORES");
             setCur(0,1); Serial.print("PANTALLA           "); if (OPMENU == 1) {Serial.print("<");};
             setCur(0,2); Serial.print("INT. CAJA          "); if (OPMENU == 2) {Serial.print("<");};
             setCur(0,3); Serial.print("SALIR              "); if (OPMENU == 3) {Serial.print("<");};
             refrescarMENU=0;
            }
              
            actuarBotonOpcion(2,90,3); // 90 PARA ABRIR SUBMENUS Y QUE NO SE JUNTEN CON EL RESTO 
       
      break;
       
///////////////////// AJUSTO TEMPERATURA SONDAS 1,2,3, PARA ENCENDER VENTILADOR DE PANTALLA
       
          case 91: 
            
              if ((OPMENU < 5)&&(refrescarMENU==1)){
              LCD_Reset(1);
              delay(300);
            
              setCur(0,0);  Serial.print("PANTALLA");
              setCur(8,0);  Serial.print(" ON    OFF  ");
              setCur(5,1);  Serial.print("SD1");
              setCur(0,2); Serial.print("ESC");
              setCur(5,2);  Serial.print("SD2");
              setCur(9,2);  Serial_printInt(sondpanon," "); Serial.print(" ");
              setCur(11,2); Serial.print(223, BYTE); Serial.print("C ");
              setCur(15,2); Serial_printInt(sondpanoff, " "); Serial.print(" ");
              setCur(17,2); Serial.print(223, BYTE); Serial.print("C ");
              setCur(0,3); Serial.print("GRA");
              setCur(5,3);  Serial.print("SD3");
              
              refrescarMENU=0;
            //delay(300);
            }
            
          if (boton_pulsado == v_menu) {OPMENU++;}
         
           if (OPMENU == 1){
             
             setCur(3,3); Serial.print(" ");
             setCur(8,2); Serial.print(">");
             setCur(9,2); actuarBotonInt(&sondpanon, 25, 45, " ");
             }
           else if (OPMENU == 2){
             setCur(8,2); Serial.print(" ");   
             setCur(14,2); Serial.print(">");
             setCur(15,2); actuarBotonInt(&sondpanoff, 20, 40, " ");
             }
           else if (OPMENU == 3) {
        ///////SALIMOS
             setCur(14,2); Serial.print(" ");
             setCur(3,2); Serial.print("<");
             if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
             CambiarAMenu(21);  
            }
            }
          else if (OPMENU == 4) {
      ///////// GRABAR Y SALIR      
            setCur(3,2); Serial.print(" ");
            setCur(3,3); Serial.print("<");
            if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
            EEPROM.write(sond_pan_on, sondpanon);
            EEPROM.write(sond_pan_off, sondpanoff);
            CambiarAMenu(21);  
            }
            }  
          else if (OPMENU == 5) {OPMENU = 1; setCur(3,3); Serial.print(" ");}
          
      break;
      
//////////////////// AJUSTO SONDA 4 PARA CONTROLAR VENTILADOR DE LA CAJA
      
         case 92: 
            
              if ((OPMENU < 6)&&(refrescarMENU==1)){
              LCD_Reset(1);
              delay(300);
            
              setCur(0,0);  Serial.print(" VENTILADOR INT CAJA ");
              setCur(9,1);  Serial.print("ON    OFF  ");
              setCur(5,2);  Serial.print("SD4");
              setCur(9,2);  Serial_printInt(sondcajon," "); Serial.print(" ");
              setCur(11,2); Serial.print(223, BYTE); Serial.print("C ");
              setCur(15,2); Serial_printInt(sondcajoff, " "); Serial.print(" ");
              setCur(17,2); Serial.print(223, BYTE); Serial.print("C ");
              setCur(0,2); Serial.print("ESC");
              setCur(0,3); Serial.print("GRA");
              refrescarMENU=0;
            //delay(300);
            }
         if (boton_pulsado == v_menu) {OPMENU++;}
         
           if (OPMENU == 1){
             setCur(3,3); Serial.print(" ");
             setCur(8,2); Serial.print(">");
             setCur(9,2); actuarBotonInt(&sondcajon, 25, 45, " ");
             }   
           else if (OPMENU == 2){
             setCur(8,2); Serial.print(" ");   
             setCur(14,2); Serial.print(">");
             setCur(15,2); actuarBotonInt(&sondcajoff, 20, 40, " ");
             }
           else if (OPMENU == 3) {
        /////// SALIMOS
             setCur(14,2); Serial.print(" ");
             setCur(3,2); Serial.print("<");
             if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
             CambiarAMenu(21);  
            }
            }
          else if (OPMENU == 4) {
      //////////GRABAR Y SALIR      
            setCur(3,2); Serial.print(" ");
            setCur(3,3); Serial.print("<");
            if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
            EEPROM.write(sond_caj_on, sondcajon );
            EEPROM.write(sond_caj_off, sondcajoff);
            CambiarAMenu(21);  
            }
            }  
          else if (OPMENU == 5) {OPMENU = 1; setCur(3,3); Serial.print(" ");}
          
      break;     
      
/////////////////// AJUSTO TEMPERATURA SONDAS 1,2,3 PARA CONTROLAR TEMPERATURAS DE LED Y
/////////////////// APAGARLOS SI ES NECESARIO
   case 22:
   
   
   if ((OPMENU < 5)&&(refrescarMENU==1)){
             LCD_Reset(1);
             setCur(5,0); Serial.print("TEMP. LEDS");
             setCur(0,1); Serial.print("T. PLUS            "); if (OPMENU == 1) {Serial.print("<");};
             setCur(0,2); Serial.print("T. ERR             "); if (OPMENU == 2) {Serial.print("<");};
             setCur(0,3); Serial.print("SALIR              "); if (OPMENU == 3) {Serial.print("<");};
             refrescarMENU=0;
            }
              
            actuarBotonOpcion(2,80,3); // 80 PARA ABRIR SUBMENUS Y QUE NO SE LIEN CON EL RESTO 
       
      break;
   
 ///////////////////// AJUSTO TEMPERATURA SONDAS 1,2,3, POR SI SE CALIENTAN UN POCO
 ///////////////////// TODAS TIENEN COMO REFERENCIA EL VALOR SOND1PLUSON Y SONDA1PLUSOFF

         case 81: 
            
              if ((OPMENU < 6)&&(refrescarMENU==1)){
              LCD_Reset(1);
              delay(300);
            
              setCur(0,0);  Serial.print("T. PLUS");
              setCur(7,0);  Serial.print("  ON    OFF  ");
              setCur(5,1);  Serial.print("SD1");
              setCur(0,2); Serial.print("ESC");
              setCur(5,2);  Serial.print("SD2");
              setCur(9,2);  Serial_printInt(sondonplus," "); Serial.print(" ");
              setCur(11,2); Serial.print(223, BYTE); Serial.print("C ");
              setCur(15,2); Serial_printInt(sondoffplus, " "); Serial.print(" ");
              setCur(17,2); Serial.print(223, BYTE); Serial.print("C ");
              setCur(0,3); Serial.print("GRA");
              setCur(5,3);  Serial.print("SD3");
              refrescarMENU=0;
            //delay(300);
            }

          if (boton_pulsado == v_menu) {OPMENU++;}

            if (OPMENU == 1){
            setCur(3,3); Serial.print(" ");
            setCur(8,2); Serial.print(">");
            setCur(9,2); actuarBotonInt(&sondonplus, 25, 45, " ");
            }
           else if (OPMENU==2){
            setCur(8,2); Serial.print(" ");   
            setCur(14,2); Serial.print(">");
            setCur(15,2); actuarBotonInt(&sondoffplus, 20, 40, " ");
            }
           else if (OPMENU == 3) {
        ///////SALIMOS
             setCur(14,2); Serial.print(" ");
             setCur(3,2); Serial.print("<");
             if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
             CambiarAMenu(22);  
            }
            }
           else if (OPMENU == 4) {
       //////// GRBAR Y SALIR      
            setCur(3,2); Serial.print(" ");
            setCur(3,3); Serial.print("<");
            if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
            EEPROM.write(sond_on_plus, sondonplus);
            EEPROM.write(sond_off_plus, sondoffplus);
            CambiarAMenu(22);  
            }
            }  
          else if (OPMENU == 5) {OPMENU = 1; setCur(3,3); Serial.print(" ");}
          
      break;
      
 ///////////////////// AJUSTO TEMPERATURA SONDAS 1,2,3, POR SI SE CALIENTAN UN MUCHO
    
       case 82: 
            
              if ((OPMENU < 6)&&(refrescarMENU==1)){
              LCD_Reset(1);
              delay(300);
            
              setCur(0,0);  Serial.print("T. ERR ");
              setCur(7,0);  Serial.print("  ON    OFF  ");
              setCur(5,1);  Serial.print("SD1");
              setCur(0,2); Serial.print("ESC");
              setCur(5,2);  Serial.print("SD2");
              setCur(9,2);  Serial_printInt(errortempon," "); Serial.print(" ");
              setCur(11,2); Serial.print(223, BYTE); Serial.print("C ");
              setCur(15,2); Serial_printInt(errortempoff, " "); Serial.print(" ");
              setCur(17,2); Serial.print(223, BYTE); Serial.print("C ");
              setCur(0,3); Serial.print("GRA");
              setCur(5,3);  Serial.print("SD3");
              refrescarMENU=0;
            //delay(300);
            }

          if (boton_pulsado == v_menu) {OPMENU++;}

            if (OPMENU == 1){
            setCur(3,3); Serial.print(" ");
            setCur(8,2); Serial.print(">");
            setCur(9,2); actuarBotonInt(&errortempon, 25, 45, " "); //CAMBIAR VALORES DESPUES DE HACE PRUEBAS
            }
           else if (OPMENU==2){
            setCur(8,2); Serial.print(" ");   
            setCur(14,2); Serial.print(">");
            setCur(15,2); actuarBotonInt(&errortempoff, 20, 40, " "); //CAMBIAR VALORES DESPUES DE HACE PRUEBAS
            }
           else if (OPMENU == 3) {
        ////// SALIMOS
             setCur(14,2); Serial.print(" ");
             setCur(3,2); Serial.print("<");
             if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
             CambiarAMenu(22);  
            }
            }
           else if (OPMENU == 4) {
       /////// GRABAR Y SALIR      
            setCur(3,2); Serial.print(" ");
            setCur(3,3); Serial.print("<");
            if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
            EEPROM.write(error_temp_on, errortempon);
            EEPROM.write(error_temp_off, errortempoff);
            CambiarAMenu(22);  
            }
            }  
          else if (OPMENU == 5) {OPMENU = 1; setCur(3,3); Serial.print(" ");}
          
      break;
      
      case 23: // SALIMOS A MENU PRINCIPAL
            
            if ((OPMENU < 6)&&(refrescarMENU==1)){
                     
               CambiarAMenu(1001);
             }
       
        break;
      
/////////////////// INFORMACION TEMPERATURAS NO SE PERMITE MODIFICAR
    
    case 3: 
                 
     if ((boton_pulsado == v_menu) |(boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {CambiarAMenu(1001);};
     
     if (refrescarLCD == 1) {    
       setCur(0,0);  Serial.print(" INFO. TEMPERATURAS ");
       
       setCur(0,1);  Serial.print("L1 ");
       setCur(7,1);  Serial.print(223, BYTE); Serial.print("C");
       setCur(9,1); Serial.print("  L2 ");
       setCur(18,1); Serial.print(223, BYTE); Serial.print("C");
       ////////////////////////////////////////////////////////
       setCur(0,2);  Serial.print("L3 "); 
       setCur(7,2);  Serial.print(223, BYTE); Serial.print("C  ");       
       setCur(11,2); Serial.print("TC "); 
       setCur(18,2); Serial.print(223, BYTE); Serial.print("C");
       /////////////////////////////////////////////////////////////  
       setCur(0,3);  Serial.print("AG "); 
       setCur(7,3);  Serial.print(223, BYTE); Serial.print("C           ");       
       
       //sensors.requestTemperatures();
       //Se entiende que le bucle principal ya se encarga de actualizar los valores de t0 a t5 cada segundo

       setCur(3,1);  Serial.print(t1, 1); //Index 1 , es el PRIMER SENSOR PANTALLA LED 1
       setCur(14,1); Serial.print(t0, 1); //Index 0 , es el SEGUNDO SENSOR PANTALLA LED 2
       setCur(3,2);  Serial.print(t2, 1); //Index 2 , es el TERCER SENSOR PANTALLA LED 3
       setCur(14,2); Serial.print(t3, 1); //Index 3 , es el CUARTO SENSOR, INTERIOR CAJACAJA
       setCur(3,3);  Serial.print(t4, 1); //Index 4 , es el QUINTO SENSOR, PARA EL AGUA
       
       refrescarLCD = 0;
       }
 
     break; 
   
 case 4:// RELOJ
       
        //Poner en fecha y hor;a
        if  (refrescarMENU==1) {
          set_year = year;
          set_month = month;
          set_dayOfMonth = dayOfMonth;
          set_hour = hour;
          set_minute = minute;
          set_second = 00;
          refrescarMENU=0;
          }
          
       
         
       
          setCur(0, 0); Serial.print(" Poner Fecha y Hora ");
          //Fecha
          setCur(0, 1); Serial.print("20"); if(set_year<10){Serial.print('0');};Serial.print(set_year); 
          setCur(4, 1); Serial.print('/'); 
          setCur(5, 1); if(set_month<10){Serial.print('0');};Serial.print(set_month); 
          setCur(7, 1); Serial.print('/'); 
          setCur(8, 1); if(set_dayOfMonth<10){Serial.print('0');};Serial.print(set_dayOfMonth);
          //Hora
          setCur(10, 1); Serial.print(" ");
          setCur(11, 1); if(set_hour<10){Serial.print('0');};Serial.print(set_hour); 
          setCur(13, 1); Serial.print(':');
          setCur(14, 1); if(set_minute<10){Serial.print('0');};Serial.print(set_minute); 
          setCur(16, 1); Serial.print(':');
          setCur(17, 1); if(set_second<10){Serial.print('0');};Serial.print(set_second);
          setCur(0,3); Serial.print("Salir         ");
          setCur(14,3); Serial.print("Grabar");
      
          
     if (boton_pulsado == v_menu) {OPMENU++;};
        
      if (OPMENU == 1){
       setCur(0, 2); Serial.print("^^^^               ");
       setCur(2, 1);  
       if (boton_pulsado == v_arriba) {set_year++;if(set_year<10){Serial.print('0');}; Serial.print(set_year);};
       if (boton_pulsado == v_abajo) {set_year--;if(set_year<10){Serial.print('0');}; Serial.print(set_year);};
       }  
     else if (OPMENU == 2){
       setCur(0,2); Serial.print("    "); setCur(5,2); Serial.print("^^"); 
       setCur(5, 1);
       if (boton_pulsado == v_arriba) {set_month++;if(set_month<10){Serial.print('0');};Serial.print(set_month);};
       if (boton_pulsado ==  v_abajo) {set_month--;if(set_month<10){Serial.print('0');};Serial.print(set_month);};
       }
     else if (OPMENU == 3){
       setCur(5, 2); Serial.print("  "); setCur(8, 2); Serial.print("^^");
       setCur(8, 1);
       if (boton_pulsado == v_arriba) {set_dayOfMonth++;if(set_dayOfMonth<10){Serial.print('0');};Serial.print(set_dayOfMonth);};
       if (boton_pulsado ==  v_abajo) {set_dayOfMonth--;if(set_dayOfMonth<10){Serial.print('0');};Serial.print(set_dayOfMonth);};
       } 
     else if (OPMENU == 4){
       setCur(8, 2); Serial.print("  "); setCur(11, 2); Serial.print("^^");
       setCur(11, 1);
       if (boton_pulsado == v_arriba) {set_hour++;if(set_hour<10){Serial.print('0');};Serial.print(set_hour);};
       if (boton_pulsado ==  v_abajo) {set_hour--;if(set_hour<10){Serial.print('0');};Serial.print(set_hour);};
       }
     else if (OPMENU == 5){
       setCur(11, 2); Serial.print("  "); setCur(14, 2); Serial.print("^^");
       setCur(14, 1);
       if (boton_pulsado == v_arriba) {set_minute++;if(set_minute<10){Serial.print('0');};Serial.print(set_minute);};
       if (boton_pulsado == v_abajo) {set_minute--;if(set_minute<10){Serial.print('0');};Serial.print(set_minute);};
       }
     else if (OPMENU == 6){
       setCur(14, 2); Serial.print("  "); setCur(17, 2); Serial.print("^^");
       setCur(17, 1);
       if (boton_pulsado == v_arriba){set_second++;if(set_second<10){Serial.print('0');};Serial.print(set_second);};
       if (boton_pulsado ==  v_abajo){set_second--;if(set_second<10){Serial.print('0');};Serial.print(set_second);};
       }
     else if (OPMENU == 7) {
         setCur(17, 2); Serial.print("  ");
         setCur(5,3); Serial.print("<");
         if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
         CambiarAMenu(1001);  
         }
         }
        
      else if (OPMENU == 8) {      
        // Grabamos los valores y salimos al menu anterior
        setCur(5,3); Serial.print(" ");
        setCur(13,3); Serial.print(">");
        
        if ((boton_pulsado == v_arriba) | (boton_pulsado == v_abajo)) {
        
        setDateDs1307(set_second, set_minute, set_hour, dayOfWeek, set_dayOfMonth, set_month, set_year); 
       CambiarAMenu(1001);  
      }
      }
    else if (OPMENU == 9) {OPMENU = 1; setCur(13,3); Serial.print(" ");}  
       
    break;
    }   
}
